/*	$Id: msg_dps.c,v 1.4 2006/06/11 02:47:05 blairdude Exp $

	Display a STRING

	This file bases on MESSAGES.C of FreeCOM v0.81 beta 1.

	$Log: msg_dps.c,v $
	Revision 1.4  2006/06/11 02:47:05  blairdude
	
	
	Optimized FreeCOM for size, fixed LFN bugs, and started an int 2e handler (which safely fails at the moment)
	
	Revision 1.3  2004/02/01 13:52:17  skaus
	add/upd: CVS $id$ keywords to/of files
	
	Revision 1.2  2001/04/29 11:33:51  skaus
	chg: default heap size (tools\ptchsize) set to 6KB
	chg: error displaying functions centralized into lib\err_fcts.src
	add: displayError()
	chg: all errors are displayed through functions void error_*()
	bugfix: somtimes error messages are not displayed (see displayError())
	bugfix: docommand(): type:file must pass ":file" to TYPE
	bugfix: error_sfile(): string _SFILE_
	bugfix: error message on empty redirection
	bugfix: comma and semicolon ';' are recognized as argument seperators
		of internal commands
	
	Revision 1.1  2001/04/12 00:33:53  skaus
	chg: new structure
	chg: If DEBUG enabled, no available commands are displayed on startup
	fix: PTCHSIZE also patches min extra size to force to have this amount
	   of memory available on start
	bugfix: CALL doesn't reset options
	add: PTCHSIZE to patch heap size
	add: VSPAWN, /SWAP switch, .SWP resource handling
	bugfix: COMMAND.COM A:\
	bugfix: CALL: if swapOnExec == ERROR, no change of swapOnExec allowed
	add: command MEMORY
	bugfix: runExtension(): destroys command[-2]
	add: clean.bat
	add: localized CRITER strings
	chg: use LNG files for hard-coded strings (hangForEver(), init.c)
		via STRINGS.LIB
	add: DEL.C, COPY.C, CBREAK.C: STRINGS-based prompts
	add: fixstrs.c: prompts & symbolic keys
	add: fixstrs.c: backslash escape sequences
	add: version IDs to DEFAULT.LNG and validation to FIXSTRS.C
	chg: splitted code apart into LIB\*.c and CMD\*.c
	bugfix: IF is now using error system & STRINGS to report errors
	add: CALL: /N
	
 */

#include "../config.h"

#include <assert.h>
#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>

#include "../include/misc.h"

#ifdef DEBUG
FILE *errStream = 0;
#else
/* static FILE *errStream = 0; */
#endif

static void displayXString(FILE *stream, unsigned id, va_list args)
{	char *str;

	if((str = getString(id)) != 0) {
		vfprintf(stream, str, args);
		free(str);
	}
}
void displayString(unsigned id,...)
{	va_list ap;

	va_start(ap, id);
	displayXString(outStream, id, ap);
	va_end(ap);
}
void displayError(unsigned id,...)
{	va_list ap;

	va_start(ap, id);
#ifdef DEBUG
	displayXString(errStream? errStream: stderr, id, ap);
#else
    displayXString( stderr, id, ap );
#endif
	va_end(ap);
}
